/*
	ProWesS, PROGS Windowing System
	PROforma, PROGS Font & Raster Manager

	DisplayError - display an error code which has to be confirmed

	This routine displays a window which informs the user about the
	error which occured, and waits for the user to indicate 'OK'.
	The error has to be passed, and ERR_OK is always returned.

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 13 December 1995
*/

#include <ProWesS.h>
#include <str.h>

Error exit(PWObject obj) { return PWChange(obj,PW_SYSTEM_BREAKDOWN,NULL); }

Error DisplayError(Error error)
{
	Error err;
	PWObject win;
	char message[ERR_MAXLEN];

	/* display an error report window */
	SMSBeep(10000,100);
	ERRMessageGet(error,message);

	err=PWCreate(NULL,&win, PW_TYPE_OUTLINE,
					PW_OUTLINE_TITLE_TEXT, "unrecoverable error",
					NULL);
	if (!err)
	{
		err=PWCreate(win,NULL, PW_TYPE_INFOSTRING,
						PW_INFOSTRING_TEXT, message,
						NULL);
		if (!err)
			err=PWCreate(win,NULL, PW_TYPE_LOOSE_ITEM,
							PW_LOOSE_TEXT, "OK",
							PW_LOOSE_ACTION_HIT, exit,
							PW_LOOSE_KEYPRESS, 27,
							NULL);
		if (!err) PWActivate(win);
		PWRemove(win);
	}
	return ERR_OK;
}
